
Script Basic User Guide
=================

* [Introduction](ug_1.md) 
* [Using ScriptBasic](ug_2.md) 
	* [Running from command line](ug_2.1.md) 
	* [Running CGI programs](ug_2.2.md) 
	* [Writing CGI programs](ug_2.3.md) 
 * [Installation Instructions](ug_3.md) 
   		* [Installation under Windows](ug_3.1.md) 
     	* [Installation under Windows from source](ug_3.1.1.md) 
   		* [Installation under Linux](ug_3.2.md) 
   		* [Installation under other Unices](ug_3.3.md) 
   * [Configuration](ug_3.4.md) 
   		* [Configuration file location under Windows NT](ug_3.5.md) 
   		* [Configuration file location under UNIX](ug_3.6.md) 
   		* [Overriding the default configuration file](ug_3.7.md) 
   		* [Trouble shooting installation](ug_3.8.md) 
* [Code caching](ug_4.md) 
	* [How cache file name is calculated](ug_4.1.md) 
	* [Cache handling shortages](ug_4.2.md) 
	* [Cache security](ug_4.3.md) 
* [Compiling BASIC programs](ug_5.md) 
* [Binary format of the BASIC code](ug_5.1.md) 
* [Compiling BASIC program to EXE](ug_6.md) 
	 * [BASIC to EXE compilation technical details](ug_6.1.md) 
	 * [Compiling BASIC programs to C](ug_7.md) 
	   		* [Compilation under Windows NT](ug_7.1.md) 
	   		* [Compilation under UNIX](ug_7.2.md) 
 * [Compiling ScriptBasic with modules](ug_8.md) 
* [General Language Format](ug_9.md) 
	* [Hello World](ug_9.1.md) 
	* [Strings](ug_9.2.md) 
	* [Numbers](ug_9.3.md) 
	* [Variables](ug_9.4.md) 
	* [Constants](ug_9.5.md) 
	* [Forcing Variable Declaration](ug_9.6.md) 
	* [Arrays](ug_9.7.md) 
 		* [Creating arrays](ug_9.7.1.md) 
 		* [Array index limits](ug_9.7.2.md) 
 		* [Deleting an array](ug_9.7.3.md) 
   * [Associative Arrays](ug_9.8.md) 
     	* [Notes for using associative arrays](ug_9.8.1.md) 
   		* [Using Array Mixed Mode](ug_9.9.md) 
   * [Expressions](ug_9.10.md) 
    	* [Operators](ug_9.10.1.md) 
       		* [Power operator (^)](ug_9.10.1.1.md) 
       		* [Multiplication operator (\*)](ug_9.10.1.2.md) 
       		* [Division operator (/)](ug_9.10.1.3.md) 
       		* [Integer division operator (\)](ug_9.10.1.4.md) 
       		* [Modulus operator (%)](ug_9.10.1.5.md) 
       		* [Addition and subtraction operators (+, -)](ug_9.10.1.6.md) 
       		* [Bit-wise and logical NOT (NOT)](ug_9.10.1.7.md) 
       		* [Equality operator (=)](ug_9.10.1.8.md) 
       		* [Not equal operator (<>)](ug_9.10.1.9.md) 
       		* [Compare operators (<, <=, >, >=)](ug_9.10.1.10.md) 
       		* [Logical operators (and, or, xor)](ug_9.10.1.11.md) 
       		* [Concatenation operator (&)](ug_9.10.1.12.md) 
       		* [ByVal operator](ug_9.10.1.13.md) 
       		* [LIKE operator](ug_9.10.1.14.md) 
       		* [Extension operators](ug_9.10.1.15.md) 
       		* [Planned, Future Operators](ug_9.10.1.16.md) 
   * [Assignments (LET)](ug_9.11.md) 
   * [Operator Assignments](ug_9.12.md) 
   * [Comments](ug_9.13.md) 
   * [Including Files](ug_9.14.md) 
   * [Internal preprocessors](ug_9.15.md) 
   * [Using external preprocessor](ug_9.16.md) 
   * [#! /usr/bin/scriba](ug_9.17.md) 
   * [@goto start](ug_9.18.md) 
   * [#!/@goto](ug_9.19.md) 
* [Interacting with the user](ug_10.md) 
   * [Print](ug_10.1.md) 
   * [Input](ug_10.2.md) 
   * [Handling command line arguments](ug_10.3.md) 
* [Name spaces](ug_11.md) 
* [File Handling](ug_12.md) 
   * [Opening and creating files](ug_12.1.md) 
   * [Text and binary files](ug_12.2.md) 
   * [Switching between binary and text mode](ug_12.3.md) 
   * [Getting a free file number](ug_12.4.md) 
   * [Positioning in a file](ug_12.5.md) 
   * [Reading and writing files](ug_12.6.md) 
   * [Getting and setting the current working directory](ug_12.7.md) 
   * [Locking a file](ug_12.8.md) 
   * [Locking file range](ug_12.9.md) 
   * [Truncating a file](ug_12.10.md) 
   * [Deleting a file or directory](ug_12.11.md) 
   * [Creating a directory](ug_12.12.md) 
   * [Setting file parameters](ug_12.13.md) 
   * [Listing files](ug_12.14.md) 
     * [Open directory](ug_12.14.1.md) 
     * [Function NextFile](ug_12.14.2.md) 
     * [Function EOD](ug_12.14.3.md) 
     * [Reset directory](ug_12.14.4.md) 
     * [Close directory](ug_12.14.5.md) 
* [Networking](ug_13.md) 
   * [Opening a Socket](ug_13.1.md) 
   * [Getting the host name](ug_13.2.md) 
* [String handling commands](ug_14.md) 
   * [Split and splita](ug_14.1.md) 
   * [Unpack](ug_14.2.md) 
* [Conditional Execution](ug_15.md) 
* [The statement GOTO](ug_16.md) 
* [Loop constructs](ug_17.md) 
 * [Functions and Subroutines](ug_18.md) 
   * [Declaration of subroutines and function](ug_18.1.md) 
   * [Calling functions and subroutines](ug_18.2.md) 
   * [Returning a value](ug_18.3.md) 
   * [Local and global variables](ug_18.4.md) 
   * [More on local and global variables](ug_18.5.md) 
   * [Parameters passed by value and by reference](ug_18.6.md) 
   * [ByVal command](ug_18.7.md) 
   * [Calling functions indirectly](ug_18.8.md) 
   * [GOSUB and RETURN](ug_18.9.md) 
* [Reference Variables](ug_19.md) 
* [Pattern matching](ug_20.md) 
   * [The operator LIKE](ug_20.1.md) 
   * [The function JOKER](ug_20.2.md) 
   * [Escaping wild cards](ug_20.3.md) 
   * [Ambiguous matching](ug_20.4.md) 
   * [Advanced matching](ug_20.5.md) 
* [Handling run-time errors](ug_21.md) 
   * [On error goto](ug_21.1.md) 
   * [Resume](ug_21.2.md) 
   * [RESUME](ug_21.3.md) 
   * [Levels of error handling](ug_21.4.md) 
   * [Error codes](ug_21.5.md) 
* [Setting options](ug_22.md) 
* [Other miscellaneous commands](ug_23.md) 
   * [Sleep](ug_23.1.md) 
* [Using External modules](ug_24.md) 
* [Command reference](ug_25.md) 
   * [ABS](ug_25.1.md) 
   * [ACOS](ug_25.2.md) 
   * [ACOSECANT](ug_25.3.md) 
   * [ACTAN](ug_25.4.md) 
   * [ADDDAY](ug_25.5.md) 
   * [ADDHOUR](ug_25.6.md) 
   * [ADDMINUTE](ug_25.7.md) 
   * [ADDMONTH](ug_25.8.md) 
   * [ADDRESS( myFunc() )](ug_25.9.md) 
   * [ADDSECOND](ug_25.10.md) 
   * [ADDWEEK](ug_25.11.md) 
   * [ADDYEAR](ug_25.12.md) 
   * [ASC(string)](ug_25.13.md) 
   * [ASECANT](ug_25.14.md) 
   * [ASIN](ug_25.15.md) 
   * [ATAN](ug_25.16.md) 
   * [ATN](ug_25.17.md) 
   * [BIN](ug_25.18.md) 
   * [BINMODE * [ # fn ] | input | output](ug_25.19.md) 
   * [CALL subroutine](ug_25.20.md) 
   * [CHDIR directory](ug_25.21.md) 
   * [CHOMP()](ug_25.22.md) 
   * [CHR(code)](ug_25.23.md) 
   * [CINT](ug_25.24.md) 
   * [CLOSE * [ # ] fn](ug_25.25.md) 
   * [CLOSE DIRECTORY * [#] dn](ug_25.26.md) 
   * [COMMAND()](ug_25.27.md) 
     * [COMMANDF Details](ug_25.27.1.md) 
   * [Concatenate operator &](ug_25.28.md) 
   * [CONF(](ug_25.29.md) 
   * [COS](ug_25.30.md) 
   * [COSECANT](ug_25.31.md) 
   * [COTAN](ug_25.32.md) 
   * [COTAN2](ug_25.33.md) 
   * [CRYPT(string,salt)](ug_25.34.md) 
   * [CURDIR()](ug_25.35.md) 
   * [CVD](ug_25.36.md) 
   * [CVI](ug_25.37.md) 
   * [CVL](ug_25.38.md) 
   * [CVS](ug_25.39.md) 
   * [DAY](ug_25.40.md) 
   * [DECLARE COMMAND function ALIAS cfun LIB library](ug_25.41.md) 
     * [DECLARE COMMAND Details](ug_25.41.1.md) 
   * [DECLARE SUB function ALIAS cfun LIB library](ug_25.42.md) 
     * [DECLARE SUB Details](ug_25.42.1.md) 
   * [DELETE file/directory_name](ug_25.43.md) 
   * [DELTREE file/directory_name](ug_25.44.md) 
   * [DO](ug_25.45.md) 
   * [DO UNTIL condition](ug_25.46.md) 
   * [DO WHILE condition](ug_25.47.md) 
   * [END](ug_25.48.md) 
   * [ENVIRON()](ug_25.49.md) 
     * [ENVIRON Details](ug_25.49.1.md) 
   * [EOD(dn)](ug_25.50.md) 
   * [EOF(n)](ug_25.51.md) 
   * [ERROR() or ERROR n](ug_25.52.md) 
   * [ERROR$() or ERROR$(n)](ug_25.53.md) 
   * [EVEN](ug_25.54.md) 
   * [EXECUTE()](ug_25.55.md) 
     * [EXECUTE Details](ug_25.55.1.md) 
     * [EXECUTE Details](ug_25.55.2.md) 
     * [EXECUTE Details](ug_25.55.3.md) 
   * [EXIT FUNCTION](ug_25.56.md) 
   * [EXIT SUB](ug_25.57.md) 
   * [EXP](ug_25.58.md) 
   * [FALSE](ug_25.59.md) 
   * [FILEACCESSTIME(file_name)](ug_25.60.md) 
   * [FILECOPY filename,filename](ug_25.61.md) 
   * [FILECREATETIME(file_name)](ug_25.62.md) 
   * [FILEEXISTS(file_name)](ug_25.63.md) 
   * [FILELEN(file_name)](ug_25.64.md) 
   * [FILEMODIFYTIME(file_name)](ug_25.65.md) 
   * [FIX](ug_25.66.md) 
   * [LOCK # fn, mode](ug_25.67.md) 
   * [FOR var=exp_start TO exp_stop * [ STEP exp_step ]](ug_25.68.md) 
   * [FORK()](ug_25.69.md) 
   * [FORMAT()](ug_25.70.md) 
   * [FORMATDATE](ug_25.71.md) 
     * [FORMATDATE Details](ug_25.71.1.md) 
   * [FILEOWNER(FileName)](ug_25.72.md) 
   * [FRAC](ug_25.73.md) 
   * [FREEFILE()](ug_25.74.md) 
   * [FUNCTION fun()](ug_25.75.md) 
     * [FUNCTION Details](ug_25.75.1.md) 
   * [GCD](ug_25.76.md) 
   * [GMTIME](ug_25.77.md) 
   * [GMTOLOCALTIME](ug_25.78.md) 
   * [GOSUB label](ug_25.79.md) 
   * [GOTO label](ug_25.80.md) 
   * [HCOS](ug_25.81.md) 
   * [HCOSECANT](ug_25.82.md) 
   * [HCTAN](ug_25.83.md) 
   * [HEX(n)](ug_25.84.md) 
   * [HOSTNAME()](ug_25.85.md) 
   * [HOUR](ug_25.86.md) 
   * [HSECANT](ug_25.87.md) 
   * [HSIN](ug_25.88.md) 
   * [HTAN](ug_25.89.md) 
   * [ICALL n,v1,v2, ... ,vn](ug_25.90.md) 
     * [ICALL Details](ug_25.90.1.md) 
   * [IF condition THEN](ug_25.91.md) 
   * [IMAX](ug_25.92.md) 
   * [IMIN](ug_25.93.md) 
   * [INPUT(n,fn)](ug_25.94.md) 
   * [INSTR(base_string,search_string * [ ,position ] )](ug_25.95.md) 
   * [INSTRREV(base_string,search_string * [ ,position ] )](ug_25.96.md) 
   * [INT](ug_25.97.md) 
   * [ISARRAY](ug_25.98.md) 
   * [ISDEFINED](ug_25.99.md) 
   * [ISDIRECTORY(file_name)](ug_25.100.md) 
   * [ISEMPTY](ug_25.101.md) 
   * [ISINTEGER](ug_25.102.md) 
   * [ISNUMERIC](ug_25.103.md) 
   * [ISREAL](ug_25.104.md) 
   * [ISFILE(file_name)](ug_25.105.md) 
   * [ISSTRING](ug_25.106.md) 
   * [ISUNDEF](ug_25.107.md) 
   * [JOIN(joiner,str1,str2,...)](ug_25.108.md) 
     * [JOIN Details](ug_25.108.1.md) 
   * [JOKER(n)](ug_25.109.md) 
     * [JOKER Details](ug_25.109.1.md) 
   * [KILL(pid)](ug_25.110.md) 
   * [LBOUND](ug_25.111.md) 
   * [LCASE()](ug_25.112.md) 
   * [LCM](ug_25.113.md) 
   * [LEFT(string,len)](ug_25.114.md) 
     * [LEFT Details](ug_25.114.1.md) 
   * [LEN()](ug_25.115.md) 
   * [v = expression](ug_25.116.md) 
   * [v &= expression](ug_25.117.md) 
   * [v /= expression](ug_25.118.md) 
   * [v \= expression](ug_25.119.md) 
   * [v -= expression](ug_25.120.md) 
   * [v += expression](ug_25.121.md) 
   * [v *= expression](ug_25.122.md) 
   * [string LIKE pattern](ug_25.123.md) 
     * [LIKE Details](ug_25.123.1.md) 
   * [LINE INPUT](ug_25.124.md) 
   * [LOC()](ug_25.125.md) 
   * [LOCATLTOGMTIME](ug_25.126.md) 
   * [LOCK # fn, mode](ug_25.127.md) 
   * [LOCK REGION # fn FROM start TO end FOR mode](ug_25.128.md) 
   * [LOF()](ug_25.129.md) 
   * [LOG](ug_25.130.md) 
   * [LOG10](ug_25.131.md) 
   * [LTRIM()](ug_25.132.md) 
   * [MAX](ug_25.133.md) 
   * [MAXINT](ug_25.134.md) 
   * [MID(string,start * [ ,len ])](ug_25.135.md) 
     * [MID Details](ug_25.135.1.md) 
   * [MIN](ug_25.136.md) 
   * [MININT](ug_25.137.md) 
   * [MINUTE](ug_25.138.md) 
   * [MKD](ug_25.139.md) 
   * [MKDIR directory_name](ug_25.140.md) 
   * [MKI](ug_25.141.md) 
   * [MKL](ug_25.142.md) 
   * [MKS](ug_25.143.md) 
   * [MONTH](ug_25.144.md) 
   * [NAME filename,filename](ug_25.145.md) 
   * [NEXTFILE(dn)](ug_25.146.md) 
   * [NOW](ug_25.147.md) 
   * [OCT(n)](ug_25.148.md) 
   * [ODD](ug_25.149.md) 
   * [ON ERROR GOTO * [ label | NULL ]](ug_25.150.md) 
   * [ON ERROR RESUME * [ label | next ]](ug_25.151.md) 
   * [OPEN file_name FOR mode AS * [ # ] i * [ LEN=record_length ]](ug_25.152.md) 
   * [OPEN DIRECTORY dir_name PATTERN pattern OPTION option AS dn](ug_25.153.md) 
   * [OPTION symbol value](ug_25.154.md) 
   * [OPTION(](ug_25.155.md) 
   * [pack(](ug_25.156.md) 
   * [PAUSE](ug_25.157.md) 
   * [PI](ug_25.158.md) 
   * [POP](ug_25.159.md) 
   * [POW](ug_25.160.md) 
   * [PRINT * [ # fn , ] print_list](ug_25.161.md) 
   * [RANDOMIZE](ug_25.162.md) 
   * [ref v1 = v2](ug_25.163.md) 
   * [REPEAT](ug_25.164.md) 
   * [REPLACE(base_string,search_string,replace_string * [,number_of_replaces] * [,position])](ug_25.165.md) 
   * [RESET](ug_25.166.md) 
   * [RESET DIRECTORY * [#] dn](ug_25.167.md) 
   * [RESUME * [ label | next ]](ug_25.168.md) 
   * [RETURN](ug_25.169.md) 
   * [REWIND * [ # ]fn](ug_25.170.md) 
   * [RIGHT(string,len)](ug_25.171.md) 
     * [RIGHT Details](ug_25.171.1.md) 
   * [RND](ug_25.172.md) 
   * [ROUND](ug_25.173.md) 
   * [RTRIM()](ug_25.174.md) 
   * [SEC](ug_25.175.md) 
   * [SECANT](ug_25.176.md) 
   * [SEEK fn,position](ug_25.177.md) 
   * [SET FILE filename parameter=value](ug_25.178.md) 
   * [SET JOKER ](ug_25.179.md) 
   * [SET WILD ](ug_25.180.md) 
   * [SIN](ug_25.181.md) 
   * [SLEEP(n)](ug_25.182.md) 
   * [SPACE(n)](ug_25.183.md) 
   * [SPLIT string BY string TO var_1,var_2,var_3,...,var_n](ug_25.184.md) 
   * [SPLITA string BY string TO array](ug_25.185.md) 
   * [SPLITAQ string BY string QUOTE string TO array](ug_25.186.md) 
   * [SQR](ug_25.187.md) 
   * [STOP](ug_25.188.md) 
   * [STR(n)](ug_25.189.md) 
     * [STR Details](ug_25.189.1.md) 
   * [STRING(n,code)](ug_25.190.md) 
   * [STRREVERSE(string)](ug_25.191.md) 
   * [SUB fun()](ug_25.192.md) 
   * [swap a,b](ug_25.193.md) 
   * [SYSTEM(executable_program)](ug_25.194.md) 
   * [TAN](ug_25.195.md) 
   * [TAN2](ug_25.196.md) 
   * [TEXTMODE * [ # fn] | input | output](ug_25.197.md) 
   * [TIMEVALUE](ug_25.198.md) 
   * [TRIM()](ug_25.199.md) 
   * [TRUE](ug_25.200.md) 
   * [TRUNCATE fn,new_length](ug_25.201.md) 
   * [TYPE](ug_25.202.md) 
   * [UBOUND](ug_25.203.md) 
   * [UCASE()](ug_25.204.md) 
   * [UNDEF variable](ug_25.205.md) 
     * [UNDEF Details](ug_25.205.1.md) 
   * [UNPACK string BY format TO v1,v2,...,vn](ug_25.206.md) 
   * [VAL](ug_25.207.md) 
   * [WAITPID(PID,ExitCode)](ug_25.208.md) 
   * [WEEKDAY](ug_25.209.md) 
   * [WHILE condition](ug_25.210.md) 
   * [YEAR](ug_25.211.md) 
   * [YEARDAY](ug_25.212.md)
   



