# Handling run-time errors

[\[\<\<\<\]](ug_20.5.md) [\[\>\>\>\]](ug_21.1.md)

*Tao says: Errors happen.*

Old programming languages like C handle error conditions returning
`NULL` pointer from a function, or returning zero, or returning non-zero
and applying system specific library functions, like `longjump`,
`setlongjump` and alike. Newer programming languages, like C++, Java
invented exception handling.

BASIC is an old language. Indeed it is a very old language. Older than
C. But it *has* exception handling.

When an error happens during program execution the program execution
stops (exit code is the code of the error or zero on errorless
termination) and usually an error message is printed on the screen. This
happens for example when a file can not be opened for reading, there is
not enough memory to perform some operation, an external module can not
be loaded for some reason, a specified file number is out of range and
many other events can cause an error.

A programmer can have two different approaches to avoid program
termination caused by program error. One approach is to check every
needed condition before trying to perform some action. This is
impractical in some cases. The other approach is to tell the BASIC
interpreter what to do instead of terminating the program when some
error occurs. Programmers usually follow a mixed style. Some conditions
are easier to check, while other errors are difficult to avoid.

For example you can not check all the conditions before trying to load a
module. To do that you have to check the BASIC setup, configuration, the
existence of the file, the existence of the functions implemented in the
file. It is not possible from basic.

-----

[\[\<\<\<\]](ug_20.5.md) [\[\>\>\>\]](ug_21.1.md)
