# Sleep

[\[\<\<\<\]](ug_23.md) [\[\>\>\>\]](ug_24.md)

The sleep command causes the basic program to stop and wait for a few
seconds. The number of seconds is given as argument. The syntax of the
command is very simple:

    SLEEP expression

The `expression` specifies the number of seconds to sleep. This is the
only effective way to insert delay into the code. Old style waiting
constructs, like empty for loops consume processor and are not precise.
The command sleep calls the system function `sleep` (`Sleep` on Windows
NT) and this allows other processes to get processor time while the
basic program is sleeping.

Because nor UNIX operating systems neither Windows NT or Windows95/98
are real time systems there is no guarantee that the basic program is
going to run immediately after the specified number of seconds has
elapsed.

Because of system limitations the time to sleep should not be more than
2,147,483 seconds. This is approximately 24 days. If you need more you
can create a loop around the sleep statement and call it many times.
This wastes a bit of CPU but not too much. If the argument to the
command sleep exceeds this limit the result is unknown.

To test the functionality of the command `SLEEP` run the following
program:

``` 

for i=1 to 20
print i
print
sleep 1
next i
```

-----

[\[\<\<\<\]](ug_23.md) [\[\>\>\>\]](ug_24.md)
