# LOCK \# fn, mode

[\[\<\<\<\]](ug_25.126.md) [\[\>\>\>\]](ug_25.128.md)

Lock a file or release a lock on a file. The `mode` parameter can be
`read`, `write` or `release`.

When a file is locked to `read` no other program is allowed to write the
file. This ensures that the program reading the file gets consistent
data from the file. If a program locks a file to read using the lock
value `read` other programs may also get the `read` lock, but no program
can get the [write](ug.md) lock. This means that any program trying to
write the file and issuing the command `LOCK` with the parameter `write`
will stop and wait until all read locks are released.

When a program write locks a file no other program can read the file or
write the file.

Note that the different operating systems and therefore ScriptBasic
running on different operating systems implement file lock in different
ways. UNIX operating systems implement so called advisory locking, while
Windows NT implements mandatory lock.

This means that a program under UNIX can write a file while another
program has a read or write lock on the file if the other program is not
good behaving and does not ask for a write lock. Therefore this command
under UNIX does not guarantee that any other program is not accessing
the file simultaneously.

Contrary Windows NT does lock the file in a hard way, and this means
that no other process can access the file in prohibited way while the
file is locked.

This different behavior usually does not make harm, but in some rare
cases knowing it may help in debugging some problems. Generally you
should not have a headache because of this.

You should use this command to synchronize the BASIC programs running
parallel and accessing the same file.

You can also use the command `LOCK REGION` to lock a part of the file
while leaving other parts of the file accessible to other programs.

If you heavily use record oriented files and file locks you may consider
using some data base module to store the data in database instead of
plain files.

-----

[\[\<\<\<\]](ug_25.126.md) [\[\>\>\>\]](ug_25.128.md)
