# SPLITAQ string BY string QUOTE string TO array

[\[\<\<\<\]](ug_25.185.md) [\[\>\>\>\]](ug_25.187.md)

Split a string into an array using the second string as delimiter. The
delimited fields may optionally be quoted with the third string. If the
string to be split has zero length the array becomes undefined. When the
delimiter is a zero length string each array element will contain a
single character of the string.

Leading and trailing delimiters are accepted and return an empty element
in the array. For example :-

``` 
   SPLITAQ ",'A,B',C," BY "," QUOTE "'" TO Result
```

will generate

``` 
                 Result[0] = ""
                 Result[1] = "A,B"
                 Result[2] = "C"
                 Result[3] = ""
```

Note that this kind of handling of trailing and leading empty elements
is different from the handling of the same by the command
[SPLIT](ug_14.1.md) and [SPLITA](ug_25.185.md) which do ignore those
empty elements. This command is useful to handle lines exported as CSV
from Excel or similar application.

The QUOTE string is really a string and need not be a single character.
If there is an unmatched quote string in the string to be split then the
rest of the string until its end is considered quoted.

If there is an unmatched

See also [SPLITA](ug_25.185.md)

This command was suggested and implemented by Andrew Kingwell
(`Andrew.Kingwell@idstelecom.co.uk`)

-----

[\[\<\<\<\]](ug_25.185.md) [\[\>\>\>\]](ug_25.187.md)
