# CONF("conf.key")

[\[\<\<\<\]](ug_25.28.md) [\[\>\>\>\]](ug_25.30.md)

This function can be used to retrieve ScriptBasic configuration
parameters. This is rarely needed by general programmers. This is needed
only for scripts that maintain the ScriptBasic setup, for example
install a new module copying the files to the appropriate location.

The argument `"conf.key"` should be the configuration key string. If
this key is not on the top level then the levels should be separated
using the dot chatacter, like `conf("preproc.internal.dbg")` to get the
debugger DLL or SO file.

The return value of the function is the integer, real or string value of
the configuration value. If the key is not defined or if the system
manager set the key to be hidden (see later) then the function will
raise an error

`(0): error &H8:The argument passed to a module function is out of the
accepted range.`

Some of the configuration values are not meant to be readable for the
BASIC programs for security reasons. A typical example is the database
connection password. The system manager can insert extra "dummy"
configuration keys that will prevent the BASIC program to get the actual
value of the configuration key. The extra configuration key has to have
the same name as the key to be hidden with a `$` sign prepended to it.

For example the MySQL connection named `test` has the connection
password under the key `mysql.connections.test.password`. If the key in
the compiled configuration file `mysql.connections.test.$password`
exists then the BASIC function `conf()` will result error. The value of
this extra key is not taken into account.

The system manager can configure whole configuration branches to be
hidden from the BASIC programs. For example the configuration key
`mysql.connections.$test` defined with any value will prevent access of
BASIC programs to any argument of the connection named `test`. Similarly
the key `mysql.$connections` will prevent access to any configuration
value of any MySQL connections if defined and finally the key `$mysql`
will stop BASIC programs to discover any MySQL configuration information
if defined.

The current implementation does not examine the actual value of the
extra security key. However later implementations may alter the
behaviour of this function based on the value of the key. To remain
compatible with later versions it is recommended that the extra security
key is configured to have the value `1`.

-----

[\[\<\<\<\]](ug_25.28.md) [\[\>\>\>\]](ug_25.30.md)
