# DECLARECOMMAND Details

[\[\<\<\<\]](ug_25.41.md) [\[\>\>\>\]](ug_25.42.md)

Declare a command implemented in an external library. Note that library
and the command implemented in it should be specifically written for
ScriptBasic. This command is not able to declare and call just any
library function.

The arguments are similar to that of the command `DECLARE SUB` and the
same restrictions and conditions apply. Look at the documentation of the
command [DECLARESUB](ug_25.42.1.md).

DEVELOPER DETAILS\!

This command is used to start an external command defined in a dynamic
load library. Please read the details of the command `DECLARE SUB` if
you did not do up to know before reading the details of this command.

The major difference between an external function and an external
command is that arguments are passed after they are evaluated to
external functions, while arguments are not evaluated for external
commands.

External commands are a bit more tedious to implement. On the other hand
external commands have more freedom handling their arguments. A command
is allowed to evaluate or not to evaluate some of its arguments. It can
examine the structure of the expression passed as argument and evaluate
it partially at its wish.

From the BASIC programmer point of view external commands are called the
same way as user defined functions or external functions.

-----

[\[\<\<\<\]](ug_25.41.md) [\[\>\>\>\]](ug_25.42.md)
